export declare function trigger(wrapper: any, eventName: string, x?: number, y?: number, options?: any): void;
export declare function sleep(delay?: number): Promise<void>;
export declare function triggerDrag(el: any, relativeX?: number, relativeY?: number): void;
/**
 * 模拟触摸移动方法
 * @param {HTMLElement} element 要进行触摸移动的 HTML 元素
 * @param {number} startX 起始触摸点的 X 坐标
 * @param {number} startY 起始触摸点的 Y 坐标
 * @param {number} endX 结束触摸点的 X 坐标
 * @param {number} endY 结束触摸点的 Y 坐标
 * @param {number} duration 移动持续时间（毫秒）
 */
export declare function simulateTouchMove(element: HTMLElement, startX: number, startY: number, endX: number, endY: number, duration: number): Promise<void>;
/**
 * 模拟触摸缩放方法
 * @param {HTMLElement} element 要进行缩放操作的 HTML 元素
 * @param {number} startDistance 起始触摸点的距离
 * @param {number} endDistance 结束触摸点的距离
 * @param {number} duration 缩放持续时间（毫秒）
 */
export declare function simulateTouchZoom(element: HTMLElement, startDistance: number, endDistance: number, duration: number): Promise<void>;
