import React from "react";
export function useRefs() {
    var refs = React.useRef([]);
    var setRefs = React.useCallback(function(index) {
        return function(el) {
            if (el) refs.current[index] = el;
        };
    }, []);
    var reset = React.useCallback(function() {
        refs.current = [];
    }, []);
    return [
        refs.current,
        setRefs,
        reset
    ];
}
