import React, { ReactNode } from 'react';
import { PopupProps } from "../popup/index";
import { CalendarDay, CalendarValue, CalendarType } from "../../types";
type CalendarRef = {
    scrollToDate: (date: string) => void;
};
export interface CalendarItemProps extends PopupProps {
    type: CalendarType;
    autoBackfill: boolean;
    popup: boolean;
    title: string;
    value?: CalendarValue;
    defaultValue?: CalendarValue;
    startDate: CalendarValue;
    endDate: CalendarValue;
    showToday: boolean;
    startText: ReactNode;
    endText: ReactNode;
    confirmText: ReactNode;
    showTitle: boolean;
    showSubTitle: boolean;
    scrollAnimation: boolean;
    firstDayOfWeek: number;
    disableDate: (date: CalendarDay) => boolean;
    renderHeaderButtons: () => string | JSX.Element;
    renderBottomButton: () => string | JSX.Element;
    renderDay: (date: CalendarDay) => string | JSX.Element;
    renderDayTop: (date: CalendarDay) => string | JSX.Element;
    renderDayBottom: (date: CalendarDay) => string | JSX.Element;
    onConfirm: (data: string) => void;
    onUpdate: () => void;
    onDayClick: (data: string) => void;
    onPageChange: (data: any) => void;
}
export declare const CalendarItem: React.ForwardRefExoticComponent<Partial<CalendarItemProps> & Omit<React.HTMLAttributes<HTMLDivElement>, ""> & React.RefAttributes<CalendarRef>>;
export {};
