import React, { FunctionComponent, ReactNode } from 'react';
import { BasicComponent } from "../../utils/typings";
import { ButtonFill, ButtonSize, ButtonType } from '../button';
export interface EmptyAction {
    text: React.ReactNode;
    type?: ButtonType;
    size?: ButtonSize;
    fill?: ButtonFill;
    disabled?: boolean;
    onClick?: () => () => void;
}
export interface EmptyProps extends BasicComponent {
    image?: ReactNode;
    imageSize: number | string;
    title: ReactNode;
    description: ReactNode;
    size: 'small' | 'base';
    status: 'empty' | 'error' | 'network';
    actions: Array<EmptyAction>;
}
export declare const Empty: FunctionComponent<Partial<EmptyProps> & Omit<React.HTMLAttributes<HTMLDivElement>, 'title'>>;
