import React, { CSSProperties, FunctionComponent } from 'react';
import { GridItem, GridItemProps } from '../griditem/griditem';
export type GridDirection = 'horizontal' | 'vertical';
export interface GridProps {
    columns: string | number;
    gap: string | number;
    center: boolean;
    square: boolean;
    reverse: boolean;
    direction: GridDirection;
    className?: string;
    style?: CSSProperties;
    onClick: (item: GridItemProps, index: number) => void;
}
export declare const Grid: FunctionComponent<Partial<GridProps> & Omit<React.HTMLAttributes<HTMLDivElement>, 'onClick'>> & {
    Item: typeof GridItem;
};
