import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type ActionSheetOption<T> = {
    [key: string]: T;
};
export type BaseActionSheet<POPUP_PROPS = any> = POPUP_PROPS & BaseProps & {
    /**
    * 遮罩层可见
    */
    visible: boolean
    /**
    * 设置列表面板副标题/描述
    */
    description: ReactNode
    /**
    * 列表项
    */
    options: ActionSheetOption<string | boolean>[]
    /**
    * 列表项的自定义设置
    */
    optionKey: ActionSheetOption<string>
    /**
    * 取消文案
    */
    cancelText: ReactNode
    /**
    * 点击取消文案时触发
    */
    onCancel: () => void
    /**
    * 选择之后触发
    */
    onSelect: (item: ActionSheetOption<string | boolean>, index: number) => void
};
