import { BaseProps } from '../../base/props';
export type AnimateType = 'shake' | 'ripple' | 'breath' | 'float' | 'slide-right' | 'slide-left' | 'slide-top' | 'slide-bottom' | 'jump' | 'twinkle' | 'flicker';
export type AnimateAction = 'initial' | 'click';
export interface BaseAnimate extends BaseProps {
    /**
    * 动画类型，见下方type值说明
    */
    type: AnimateType
    /**
    * 触发方式，'initial'初始化执行; 'click'点击执行
    */
    action: AnimateAction
    /**
    * 是否循环执行。true循环执行;false执行一次
    */
    loop: boolean
    /**
    * 点击元素时触发
    */
    onClick: (event: any) => void
}
