import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { PositionX, UIRound } from '../../base/atoms';
export interface BaseAvatar extends BaseProps {
    /**
    * 设置头像的大小
    */
    size: string
    /**
    * 设置 Icon 类型头像图标
    */
    icon: ReactNode
    /**
    * 设置头像的形状
    */
    shape: UIRound
    /**
    * 设置 Icon、字符类型头像的背景色
    */
    background: string
    /**
    * 设置 Icon、字符类型头像的颜色
    */
    color: string
    /**
    * 图片填充模式
    */
    fit: 'contain' | 'cover' | 'fill' | 'none' | 'scale-down'
    /**
    * 设置图片类型头像的地址
    */
    src: string
    /**
    * 设置图片类型头像无法显示时的替代文本
    */
    alt: string
    /**
    * 点击头像触发事件
    */
    onClick: (e: any) => void
    /**
    * 图片加载失败的事件
    */
    onError: () => void
}
export interface BaseAvatarGroup extends BaseProps {
    maxContent: string;
    max: string | number;
    maxBackground: string;
    maxColor: string;
    size: 'large' | 'normal' | 'small';
    shape: UIRound;
    gap: string;
    level: PositionX;
}
