import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { PositionY, UIRound } from "../../../types";
export type AvatarCropperSizeType = 'original' | 'compressed';
export type AvatarCropperSourceType = 'album' | 'camera';
export interface BaseAvatarCropper extends BaseProps {
    /**
    * 最大缩放倍数
    */
    maxZoom: number
    /**
    * 裁剪区域两边预留的间隙
    */
    space: number
    /**
    * 自定义裁剪区域工具栏
    */
    toolbar: ReactNode[]
    /**
    * 裁剪区域工具栏位置,可选值为：top bottom
    */
    toolbarPosition: PositionY
    /**
    * 中间的文字内容
    */
    editText: ReactNode
    /**
    * 裁剪形状,可选值为：square round
    */
    shape: UIRound
    /**
    * 裁剪后点击确认触发
    */
    onConfirm: (e: any) => void
    /**
    * 点击取消触发
    */
    onCancel: () => void
}
