import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export type BadgeFill = 'solid' | 'outline';
export type BadgeDotSize = 'small' | 'normal' | 'large';
export interface BaseBadge extends BaseProps {
    /**
    * 显示的内容，支持数字、字符和自定义内容
    */
    value: ReactNode
    /**
    * 是否为小点，当value值为自定义内容时，dot不生效
    */
    dot: boolean
    /**
    * value 为数值时，最大值
    */
    max: number
    /**
    * 上下偏移量，可设置为："0"或0 等
    */
    top: SimpleValue
    /**
    * 左右偏移量，可设置为："0"或0 等
    */
    right: SimpleValue
    /**
    * 填充模式
    */
    fill: BadgeFill
    /**
    * dot 尺寸，当 dot 等于 true 时生效
    */
    size: BadgeDotSize
    /**
    * 是否禁用
    */
    disabled: boolean
}
