import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { UIFill, UIRound, UISize, UIType } from '../../base/atoms';
export interface BaseButton extends BaseProps {
    /**
    * 按钮颜色，支持传入 linear-gradient 渐变色, outline 和 dashed 模式下设置的是 color，其他情况设置的是background，建议使用CSS变量实现的颜色配置
    */
    color: string
    /**
    * 按钮的形状
    */
    shape: UIRound
    /**
    * 按钮的样式
    */
    type: UIType
    /**
    * 按钮的尺寸
    */
    size: UISize
    /**
    * 填充模式
    */
    fill: UIFill
    /**
    * 是否为块级元素
    */
    block: boolean
    /**
    * 按钮loading状态
    */
    loading: boolean
    /**
    * 是否禁用按钮
    */
    disabled: boolean
    /**
    * 按钮图标
    */
    icon: ReactNode
    /**
    * 右侧按钮图标
    */
    rightIcon: ReactNode
    id: string;
    /**
    * 按钮原始类型
    */
    nativeType: 'submit' | 'reset' | 'button'
    /**
    * 点击按钮时触发
    */
    onClick: (e: any) => void
}
