import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { FlexAlign } from '../../base/atoms';
export interface BaseCell extends BaseProps {
    /**
    * 标题
    */
    title: ReactNode
    /**
    * 描述
    */
    description: ReactNode
    /**
    * 右侧描述
    */
    extra: ReactNode
    /**
    * 圆角半径
    */
    radius: string | number
    /**
    * 纵轴方向上的对齐方式
    */
    align: FlexAlign
    /**
    * 点击的样式反馈
    */
    clickable: boolean
    isLast: boolean;
    /**
    * 点击事件
    */
    onClick: (event: any) => void
}
export interface BaseCellGroup extends BaseProps {
    title: ReactNode;
    description: ReactNode;
    children: ReactNode;
    divider: boolean;
}
