import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface BaseCircleProgress extends BaseProps {
    /**
    * 百分比
    */
    percent: SimpleValue
    /**
    * 圆弧的宽度
    */
    strokeWidth: SimpleValue
    /**
    * 半径
    */
    radius: SimpleValue
    /**
    * 圆环进度条端点形状
    */
    strokeLinecap: 'butt' | 'round' | 'square' | 'inherit'
    /**
    * 圆环进度条颜色，传入对象格式可以定义渐变色
    */
    color: Record<string, string> | string
    /**
    * 圆环轨道颜色
    */
    background: string
    /**
    * 是否顺时针展示
    */
    clockwise: boolean
}
