import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type CollapseActiveName = Array<string> | string;
export interface BaseCollapse extends BaseProps {
    /**
    * 当前展开面板的 name，受控
    */
    activeName: CollapseActiveName
    /**
    * 默认展开面板的 name，非受控
    */
    defaultActiveName: CollapseActiveName
    /**
    * 是否开启手风琴模式
    */
    accordion: boolean
    /**
    * 自定义展开图标
    */
    expandIcon: ReactNode
    /**
    * 点击折叠和展开的旋转角度,在自定义图标模式下生效
    */
    rotate: number
    onChange: (activeName: CollapseActiveName, name: string, isOpen: boolean) => void;
}
export interface BaseCollapseItem extends BaseProps {
    title: ReactNode;
    name: string;
    expandIcon: ReactNode;
    disabled: boolean;
    rotate: number;
    extra: ReactNode;
}
