import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type CountDownType = 'default' | 'primary' | 'text';
export interface CountDownTime {
    d: number;
    h: number;
    m: number;
    s: number;
    ms: number;
}
export interface BaseCountDown extends BaseProps {
    /**
    * 展示类型
    */
    type: CountDownType
    /**
    * 是否暂停
    */
    paused: boolean
    /**
    * 开始时间
    */
    startTime: number
    /**
    * 结束时间
    */
    endTime: number
    /**
    * 剩余时间，单位是毫秒
    */
    remainingTime: number
    /**
    * 是否开启毫秒级渲染
    */
    millisecond: boolean
    /**
    * 时间格式
    */
    format: string
    /**
    * 是否自动开始倒计时
    */
    autoStart: boolean
    /**
    * 倒计时显示时间，单位是毫秒。autoStart 为 false 时生效
    */
    time: number
    /**
    * 销毁实例
    */
    destroy: boolean
    /**
    * 倒计时结束时回调函数
    */
    onEnd: () => void
    /**
    * 暂停倒计时回调函数
    */
    onPaused: (restTime: number) => void
    /**
    * 重新开始倒计时回调函数
    */
    onRestart: (restTime: number) => void
    /**
    * 自定义展示内容时，实时更新倒计时数据回调函数
    */
    onUpdate: (restTime: string | CountDownTime) => void
    children: ReactNode;
}
