import { BaseProps } from '../../base/props';
export interface DragState {
    offset: [x: number, y: number];
}
export interface BaseDrag extends BaseProps {
    /**
    * 是否开启自动吸边
    */
    attract: boolean
    /**
    * 拖拽元素的拖拽方向限制
    */
    direction: 'x' | 'y' | 'lock' | undefined
    /**
    * 拖拽元素的拖拽边界
    */
    boundary: {
        top: number;
        left: number;
        right: number;
        bottom: number;
    }
    /**
    * 开始拖拽元素
    */
    onDragStart: () => void
    /**
    * 停止拖拽元素
    */
    onDragEnd: (state: DragState) => void
    /**
    * 拖拽元素
    */
    onDrag: (state: DragState) => void
}
