import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface ElevatorItem {
    name: string;
    id: SimpleValue;
    [key: string]: SimpleValue;
}
export type ElevatorFloorKey = string;
export type ElevatorList = {
    list: Array<ElevatorItem>;
} & {
    [key: ElevatorFloorKey]: string;
};
export interface BaseElevator extends BaseProps {
    /**
    * 电梯区域的高度
    */
    height: SimpleValue
    /**
    * 索引 key 值
    */
    floorKey: ElevatorFloorKey
    /**
    * 索引列表
    */
    list: ElevatorList[]
    /**
    * 索引是否吸顶
    */
    sticky: boolean
    /**
    * 右侧锚点的上下间距
    */
    spaceHeight: number
    /**
    * 左侧索引的高度
    */
    titleHeight: number
    /**
    * 展示右侧导航
    */
    showKeys: boolean
    /**
    * 点击内容
    */
    onItemClick: (key: string, item: ElevatorItem) => void
    /**
    * 点击索引
    */
    onIndexClick: (key: string) => void
}
