import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export type EllipsisDirection = 'start' | 'end' | 'middle';
export type EllipsisState = 'expand' | 'collapse';
export interface BaseEllipsis extends BaseProps {
    /**
    * 文本内容
    */
    content: string
    /**
    * 省略位置
    */
    direction: EllipsisDirection
    /**
    * 展示几行
    */
    rows: SimpleValue
    /**
    * 展开操作的文案
    */
    expandText: string
    /**
    * 收起操作的文案
    */
    collapseText: string
    /**
    * 省略的符号
    */
    symbol: string
    /**
    * 容器的行高
    */
    lineHeight: SimpleValue
    /**
    * 文本点击时触发
    */
    onClick?: () => void
    /**
    * 点击展开收起时触发
    */
    onChange?: (type: EllipsisState) => void
}
