import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue, UIFill, UISize, UIType } from '../../base/atoms';
export interface EmptyAction {
    text: ReactNode;
    type: UIType;
    size: UISize;
    fill: UIFill;
    disabled: boolean;
    onClick: () => void;
}
export type EmptyState = 'empty' | 'error' | 'network';
export interface BaseEmpty extends BaseProps {
    /**
    * 图片,支持传入图片 URL
    */
    image: ReactNode
    /**
    * 图片大小，number 类型单位为 px
    */
    imageSize: SimpleValue
    /**
    * 图片下方的标题
    */
    title: ReactNode
    /**
    * 图片下方的描述文字
    */
    description: ReactNode
    /**
    * 组件整体大小，适配于全屏或半屏
    */
    size: Extract<UISize, 'small' | 'base'>
    /**
    * 默认图片错误类型
    */
    status: EmptyState
    /**
    * 可用于处理操作的一组数据
    */
    actions: Array<EmptyAction>
}
