import { Key, ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { PositionX } from '../../base/atoms';
export type FixedNavPosition = {
    top?: 'auto';
    bottom?: 'auto';
};
export interface FixedNavItem {
    id: Key;
    num?: number;
    text: ReactNode;
    icon: ReactNode;
}
export type BaseFixedNav<OverlayProps> = OverlayProps & BaseProps & {
    /**
    * 展开时是否显示遮罩
    */
    overlay: boolean
    /**
    * 收起列表按钮文案
    */
    activeText: string
    /**
    * 展开列表按钮文案
    */
    inactiveText: string
    /**
    * fixed 垂直位置
    */
    position: FixedNavPosition
    /**
    * 导航方向
    */
    type: PositionX
    /**
    * 自定义按钮
    */
    content?: ReactNode
    /**
    * 悬浮列表内容数据
    */
    list: Array<FixedNavItem>
    /**
    * 展开收起按钮回调
    */
    onChange: (value: boolean) => void
    /**
    * 选择之后触发
    */
    onSelect: (item: FixedNavItem, event: any) => void
};
