import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { Direction, SimpleValue } from '../../base/atoms';
export interface BaseGrid extends BaseProps {
    /**
    * 列数
    */
    columns: SimpleValue
    /**
    * 格子之间的间距，默认单位为px
    */
    gap: SimpleValue
    /**
    * 是否将格子内容居中显示
    */
    center: boolean
    /**
    * 是否将格子固定为正方形
    */
    square: boolean
    /**
    * 内容翻转
    */
    reverse: boolean
    /**
    * 格子内容排列的方向
    */
    direction: Direction
    /**
    * 宫格子项点击事件
    */
    onClick: (item: BaseGridItem, index: number) => void
}
export interface BaseGridItem extends BaseProps {
    text: ReactNode;
    index: number;
    columns: SimpleValue;
    gap: SimpleValue;
    center: boolean;
    square: boolean;
    reverse: boolean;
    direction: Direction;
}
