import { BaseProps } from '../../base/props';
import { UIType } from '../../base/atoms';
export type IndicatorType = 'anchor' | 'slide' | 'dualScreen';
export type IndicatorColor = Extract<UIType, 'primary' | 'default'>;
export interface BaseIndicator extends BaseProps {
    /**
    * 总页数
    */
    total: number
    /**
    * 当前页
    */
    current: number
    /**
    * 方向，默认为水平方向
    */
    direction: string
    /**
    * 颜色
    */
    color: IndicatorColor
    /**
    * 交互类型
    */
    type: IndicatorType
}
