import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { UIType } from '../../base/atoms';
export type InfiniteLoadingType = Extract<UIType, 'primary' | 'default'>;
export interface BaseInfiniteLoading extends BaseProps {
    /**
    * 主题类型
    */
    type: InfiniteLoadingType
    /**
    * 是否还有更多数据
    */
    hasMore: boolean
    /**
    * 距离底部多远加载
    */
    threshold: number
    /**
    * 获取监听的目标元素
    */
    target: string
    /**
    * 是否使用捕获模式 true 捕获 false 冒泡
    */
    capture: boolean
    /**
    * 是否开启下拉刷新
    */
    pullRefresh: boolean
    /**
    * 下拉刷新提示文案
    */
    pullingText: ReactNode
    /**
    * 上拉加载提示文案
    */
    loadingText: ReactNode
    /**
    * “没有更多数据”展示文案
    */
    loadMoreText: ReactNode
    /**
    * 下拉刷新事件回调
    */
    onRefresh: () => Promise<void>
    /**
    * 继续加载的回调函数
    */
    onLoadMore: () => Promise<void>
    /**
    * 实时监听滚动高度
    */
    onScroll: (param: number) => void
}
