import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface BaseInputNumber extends BaseProps {
    /**
    * 当前值，受控值
    */
    value: SimpleValue
    /**
    * 默认值
    */
    defaultValue: SimpleValue
    /**
    * 是否允许内容为空
    */
    allowEmpty: boolean
    /**
    * 最小值限制
    */
    min: SimpleValue
    /**
    * 最大值限制
    */
    max: SimpleValue
    /**
    * 禁用所有功能
    */
    disabled: boolean
    /**
    * 只读状态禁用输入框操作行为
    */
    readOnly: boolean
    /**
    * 步长
    */
    step: number
    /**
    * 设置保留的小数位
    */
    digits: number
    /**
    * 支持取消文本全选中
    */
    select: boolean
    /**
    * 指定输入框展示值的格式
    */
    formatter?: (value?: SimpleValue) => string
    /**
    * 点击增加按钮时触发
    */
    onPlus: (e: any) => void
    /**
    * 点击减少按钮时触发
    */
    onMinus: (e: any) => void
    /**
    * 点击不可用的按钮时触发
    */
    onOverlimit: (e: any) => void
    /**
    * 输入框失去焦点时触发
    */
    onBlur: (e: any) => void
    /**
    * 输入框获得焦点时触发
    */
    onFocus: (e: any) => void
    beforeChange: (value: SimpleValue) => boolean | Promise<boolean>;
    /**
    * 值改变时触发
    */
    onChange: (param: string | number, e: any) => void
}
