import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export type MenuTriggerType = 'NORMAL' | 'REF';
export type MenuCallBack = (index: number, from?: MenuTriggerType) => void;
export interface MenuOptionItem {
    text: string;
    value: SimpleValue;
}
export interface BaseMenu extends BaseProps {
    /**
    * 选项的选中态图标颜色
    */
    activeColor: string
    overlay: boolean;
    /**
    * 是否在点击遮罩层后关闭菜单
    */
    closeOnOverlayClick: boolean
    /**
    * 滚动后是否固定，可设置固定位置
    */
    scrollFixed: boolean | SimpleValue
    /**
    * 背景是否锁定
    */
    lockScroll: boolean
    /**
    * 自定义标题图标
    */
    icon: ReactNode
    children: ReactNode;
    /**
    * menu 展开触发
    */
    onOpen: MenuCallBack
    /**
    * menu 关闭触发
    */
    onClose: MenuCallBack
}
export interface BaseMenuItem extends BaseProps {
    title: ReactNode;
    titleIcon: ReactNode;
    options: MenuOptionItem[];
    disabled: boolean;
    columns: number;
    icon: ReactNode;
    closeOnClickAway: boolean;
    direction: string;
    activeTitleClass: string;
    inactiveTitleClass: string;
    value: SimpleValue;
    defaultValue: SimpleValue;
    children: ReactNode;
    onChange: (event: any) => void;
}
