import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface BaseNavBar extends BaseProps {
    /**
    * 左侧内容，渲染在返回区域的右侧
    */
    left: ReactNode
    /**
    * 返回区域的文字
    */
    back: ReactNode
    /**
    * 右侧内容
    */
    right: ReactNode
    /**
    * 标题
    */
    title: ReactNode
    /**
    * 是否固定
    */
    fixed: boolean
    /**
    * 是否适配安全区
    */
    safeAreaInsetTop: boolean
    /**
    * 固定在顶部时，是否在标签位置生成一个等高的占位元素
    */
    placeholder: boolean
    /**
    * 导航栏层级
    */
    zIndex: SimpleValue
    /**
    * 点击返回区域后的回调
    */
    onBackClick: (e: any) => void
    children?: ReactNode;
}
