import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { Align } from '../../base/atoms';
export type NoticeBarAlign = Extract<Align, 'left' | 'center'>;
export interface BaseNoticeBar extends BaseProps {
    /**
    * 布局方式, 值为center时，不支持滚动
    */
    align: Extract<Align, 'left' | 'center'>
    /**
    * 滚动的方向，可选 horizontal、vertical
    */
    direction: string
    list: any;
    duration: number;
    height: number;
    /**
    * 提示的信息
    */
    content: string
    /**
    * 是否启用关闭模式
    */
    closeable: boolean
    /**
    * 是否开启文本换行
    */
    wrap: boolean
    /**
    * 左边的 icon，closeable 模式下默认为空
    */
    leftIcon: ReactNode
    /**
    * 右边的 icon，在 closeable 模式下默认为 <Close />
    */
    rightIcon: ReactNode
    /**
    * 区别于rightIcon，为右边自定义区域，仅用于 direction='horizontal' 模式
    */
    right: ReactNode
    /**
    * 延时多少秒
    */
    delay: string | number
    /**
    * 是否可以滚动
    */
    scrollable: boolean | null
    /**
    * 滚动速率 (px/s)
    */
    speed: number
    close?: (event: any) => void;
    click?: (event: any) => void;
    /**
    * 关闭通知栏时触发
    */
    onClose?: (event: any) => void
    /**
    * 外层点击事件回调
    */
    onClick?: (event: any) => void
    /**
    * 垂直滚动多条数据时，点击当前展示的信息时触发
    */
    onItemClick?: (event: any, value: any) => void
}
