import { PositionY } from "../../base/atoms";
import { BaseProps } from '../../base/props';
export interface BaseNotify extends BaseProps {
    id: string;
    /**
    * 距离顶部/底部距离
    */
    distance: number
    /**
    * 顶部导航高度
    */
    navHeight: number
    /**
    * 是否启用关闭模式
    */
    closeable: boolean
    /**
    * 左边的 icon
    */
    leftIcon: React.ReactNode
    /**
    * 右边的 icon，在 closeable 模式下默认为 <Close />
    */
    rightIcon: React.ReactNode
    /**
    * 自定义位置 (top, bottom)
    */
    position: PositionY
    /**
    * 展示时长(ms)，值为 0 时，notify 不会消失
    */
    duration: number
    /**
    * 点击事件回调
    */
    onClick: () => void
    /**
    * 关闭事件回调
    */
    onClose: () => void
}
