import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type BaseNumberKeyboard<POPUP_PROPS = any> = POPUP_PROPS & BaseProps & {
    /**
    * 是否显示键盘
    */
    visible: boolean
    /**
    * 标题右侧内容
    */
    rightActions: ReactNode
    /**
    * 自定义完成按钮文字，如"支付"，"下一步"，"提交"等，搭配 rightColumn 使用
    */
    confirmText: string
    /**
    * 键盘模式, default：默认样式 rightColumn：带右侧栏
    */
    type: 'default' | 'rightColumn'
    /**
    * 自定义键盘额外的键, 数组形式最多支持添加 2 个, 超出默认取前 2 项
    */
    custom: Array<string>
    /**
    * 随机数
    */
    random: boolean
    /**
    * 点击按键时触发
    */
    onChange: (value: string) => void
    /**
    * 点击删除键时触发
    */
    onDelete: () => void
    /**
    * 点击关闭按钮或非键盘区域时触发
    */
    onClose: () => void
    /**
    * 点击确定按钮时触发
    */
    onConfirm: () => void
};
