import { BaseProps } from '../../base/props';
export interface BaseOverlay extends BaseProps {
    /**
    * 设置组件页面层级
    */
    zIndex: number
    /**
    * 动画时长，单位毫秒
    */
    duration: number
    /**
    * 当前组件是否显示
    */
    visible: boolean
    /**
    * 背景是否锁定，strict 用于支持 iOS12
    */
    lockScroll: boolean
    /**
    * 是否点击遮罩关闭
    */
    closeOnOverlayClick: boolean
    /**
    * 完全展示后触发
    */
    afterShow: () => void
    /**
    * 完全关闭后触发
    */
    afterClose: () => void
    /**
    * 点击时触发
    */
    onClick: (event: any) => void
}
