import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export interface BasePagination extends BaseProps {
    /**
    * 默认页码，非受控
    */
    defaultValue: number
    /**
    * 当前页码，受控值，与 onChange 搭配使用
    */
    value: number
    /**
    * 显示模式
    */
    mode: 'multi' | 'simple' | 'lite'
    /**
    * 自定义上一页按钮内容
    */
    prev: ReactNode
    /**
    * 自定义下一页按钮内容
    */
    next: ReactNode
    /**
    * 总记录数
    */
    total: number
    /**
    * 每页记录数
    */
    pageSize: number
    /**
    * 显示的页码个数
    */
    itemSize: number
    /**
    * 是否显示省略号
    */
    ellipse: boolean
    /**
    * 用于自定义页码的结构
    */
    itemRender: (page: any, index: number) => ReactNode
    /**
    * 页码改变时触发
    */
    onChange: (currPage: number) => void
}
