import { BaseProps } from '../../base/props';
import { PickerOnChangeCallbackParameter, PickerOption, PickerOptions, PickerValue } from '../picker/base';
export interface BasePickerView extends BaseProps {
    setRefs?: (ref: any) => any;
    /**
    * 列表数据
    */
    options: PickerOptions[]
    /**
    * 选中值，受控
    */
    value?: PickerValue[]
    /**
    * 默认选中
    */
    defaultValue?: PickerValue[]
    /**
    * 是否开启3D效果
    */
    threeDimensional?: boolean
    /**
    * 快速滑动时惯性滚动的时长，单位 ms
    */
    duration?: number | string
    renderLabel: (item: PickerOption) => React.ReactNode;
    /**
    * 每一列值变更时调用
    */
    onChange?: (arg0: PickerOnChangeCallbackParameter) => void
}
