import { BaseProps } from '../../base/props';
import { SimpleValue, UISize } from '../../base/atoms';
export type PriceSize = Exclude<UISize, 'mini'>;
export type PriceColor = 'primary' | 'gray' | 'darkgray';
export interface BasePrice extends BaseProps {
    /**
    * 价格类型
    */
    color: PriceColor
    /**
    * 价格数量
    */
    price: SimpleValue
    /**
    * 符号类型
    */
    symbol: string
    /**
    * 小数位位数
    */
    digits: number
    /**
    * 是否按照千分号形式显示
    */
    thousands: boolean
    /**
    * 符号显示在价格前或者后，before、after
    */
    position: string
    /**
    * 价格尺寸，xlarge | large | normal | small
    */
    size: PriceSize
    /**
    * 是否划线价
    */
    line: boolean
}
