import { BaseProps } from '../../base/props';
export interface BaseProgress extends BaseProps {
    /**
    * 百分比
    */
    percent: number
    /**
    * 进度条背景颜色
    */
    background: string
    /**
    * 进度条线条颜色
    */
    color: string
    /**
    * 进度条宽度
    */
    strokeWidth: string
    /**
    * 是否显示文字内容
    */
    showText: boolean
    /**
    * 是否展示动画效果
    */
    animated: boolean
    /**
    * 每次进入可视区展示进度条动画
    */
    lazy: boolean
    /**
    * 延迟数据加载时长，单位 ms
    */
    delay: number
    /**
    * 进度条圆角大小
    */
    borderRadius: string
    /**
    * 进度文字大小
    */
    fontSize: string
    /**
    * 动画播放方式
    */
    activeMode: string
    /**
    * 动画完成时间（单位：毫秒）
    */
    duration: number
    /**
    * 无障碍标签
    */
    ariaLabel: string
    /**
    * 动画完成后的回调函数
    */
    onActiveEnd: () => void
}
