import { ReactNode } from 'react';
import { UIFill, UISize, UIType } from '../../base/atoms';
import { BaseProps } from '../../base/props';
export type ResultPageStatusOptions = {
    [key: string]: React.ReactNode;
};
export type ResultPageStatus = 'success' | 'error' | 'warning' | 'info' | 'waiting';
export type ResultPageAction = {
    text: ReactNode;
    type?: UIType;
    size?: UISize;
    fill?: UIFill;
    disabled?: boolean;
    onClick?: () => void;
};
export interface BaseResultPage extends BaseProps {
    /**
    * 标题
    */
    title: ReactNode
    /**
    * 描述，最多展示两行
    */
    description: ReactNode
    /**
    * 自定义 icon
    */
    icon: ReactNode
    /**
    * 状态类型
    */
    status: ResultPageStatus
    /**
    * 可用于处理操作的一组数据
    */
    actions: ResultPageAction[]
}
