import { ReactNode } from 'react';
import { UIRound } from '../../base/atoms';
import { BaseProps } from '../../base/props';
export interface BaseSearchBar extends BaseProps {
    /**
    * 当前输入的值，受控
    */
    value: string
    /**
    * 当前默认值，支持通过','分割成多个
    */
    defaultValue: string
    /**
    * 输入框默认暗纹
    */
    placeholder: string
    /**
    * 搜索框形状，可选值为 round
    */
    shape: UIRound
    /**
    * 是否禁用输入框
    */
    disabled: boolean
    /**
    * 最大输入长度
    */
    maxLength: number
    /**
    * 是否展示清除按钮
    */
    clearable: boolean
    /**
    * 输入框只读
    */
    readOnly: boolean
    /**
    * 是否自动聚焦
    */
    autoFocus: boolean
    /**
    * 是否展示返回按钮
    */
    backable: boolean
    /**
    * 搜索框左侧区域
    */
    left: ReactNode
    /**
    * 搜搜框右侧区域
    */
    right: ReactNode
    /**
    * 输入框内左侧区域
    */
    leftIn: ReactNode
    /**
    * 输入框内右侧区域
    */
    rightIn: ReactNode
    tag: boolean;
    /**
    * 确定搜索时触发
    */
    onSearch: (val: string) => void
    /**
    * 输入内容时触发
    */
    onChange: (value: string, e: any) => void
    /**
    * 聚焦时触发
    */
    onFocus: (value: string, e: any) => void
    /**
    * 失焦时触发
    */
    onBlur: (value: string, e: any) => void
    /**
    * 点击清空时触发
    */
    onClear: (e: any) => void
    /**
    * 点击输入区域时触发
    */
    onInputClick: (e: any) => void
    /**
    * 点击默认值的x号触发
    */
    onItemClick: (value: string, e: any) => void
}
