import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue, SimpleValues } from '../../base/atoms';
export interface SegmentedItem {
    label: ReactNode;
    value: string | number;
    icon?: ReactNode;
    disabled?: boolean;
    className?: string;
}
export interface BaseSegmented extends BaseProps {
    /**
    * 选项内容
    */
    options: SimpleValues | SegmentedItem[]
    /**
    * 当前选中的值
    */
    value: SimpleValue
    /**
    * 默认值
    */
    defaultValue: SimpleValue
    /**
    * 选项变化时的回调函数
    */
    onChange: (value: SimpleValue) => void
}
