import { ReactNode } from 'react';
export type ShortPasswordRef = {
    open: () => void;
    close: () => void;
};
export type BaseShortPassword<POPUP_PROPS = any> = POPUP_PROPS & {
    /**
    * 密码字符串
    */
    value: string
    /**
    * 是否展示短密码框
    */
    visible: boolean
    /**
    * 是否展示明文
    */
    plain: boolean
    /**
    * 标题
    */
    title: ReactNode
    /**
    * 密码框描述
    */
    description: ReactNode
    /**
    * 提示语
    */
    tips: ReactNode
    /**
    * 是否隐藏底部按钮
    */
    hideFooter: boolean
    /**
    * 密码长度，取值为4~6
    */
    length: number
    /**
    * 错误信息提示
    */
    error: ReactNode
    /**
    * 自动聚焦
    */
    autoFocus: boolean
    /**
    * 输入框聚焦
    */
    onFocus: () => void
    /**
    * 输入密码时触发事件
    */
    onChange: (value: string) => void
    /**
    * 点击确认时触发事件
    */
    onConfirm: (value: string) => void
    /**
    * 点击取消时触发事件
    */
    onCancel: () => void
    /**
    * 点击关闭图标和遮罩时触发事件
    */
    onClose: () => void
    /**
    * 点击忘记密码时触发事件
    */
    onTips: () => void
    /**
    * 输入完成的回调
    */
    onComplete: (value: string) => void
};
