import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface BaseSideBarItem extends BaseProps {
    title: string;
    disabled: boolean;
    active?: boolean;
    value: SimpleValue;
}
export interface BaseSideBar extends BaseProps {
    /**
    * 当前激活的item的key
    */
    value: SimpleValue
    /**
    * 未设置value时，item的key的默认值
    */
    defaultValue: SimpleValue
    /**
    * 内容滚动动画时长
    */
    contentDuration: number
    /**
    * 侧栏滚动动画时长
    */
    sidebarDuration: number
    /**
    * 当前激活的标签改变时触发
    */
    onChange: (index: SimpleValue) => void
    /**
    * 点击标签时触发
    */
    onClick: (index: SimpleValue) => void
    children?: ReactNode;
}
