import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type SignatureType = 'jpg' | 'png';
export interface BaseSignature extends BaseProps {
    /**
    * 图片格式
    */
    type: SignatureType
    /**
    * 线条的宽度
    */
    lineWidth: number
    /**
    * 绘图笔触颜色
    */
    strokeStyle: string
    /**
    * 不支持 Canvas 情况下的展示文案
    */
    unsupported: ReactNode
    /**
    * 点击确认按钮触发事件回调函数
    */
    onConfirm: () => void
    /**
    * 点击重签按钮触发事件回调函数
    */
    onClear: () => void
}
