import { BaseProps } from '../../base/props';
import { SimpleValue, UIRound, UISize } from '../../base/atoms';
export type avatarShape = 'round' | 'square';
export interface BaseSkeleton extends BaseProps {
    /**
    * 设置行数
    */
    rows: number
    /**
    * 指定使用的内置高度
    */
    size: Extract<UISize, 'small' | 'normal' | 'large'>
    /**
    * 设置宽度，优先级高于 size 属性
    */
    width?: SimpleValue
    /**
    * 设置高度，优先级高于 size 属性
    */
    height?: SimpleValue
    /**
    * 设置形状
    */
    shape: UIRound | 'circle'
    /**
    * 是否开启骨架屏动画
    */
    animated: boolean
    /**
    * 动画时长
    */
    duration: number
    /**
    * 是否显示骨架屏(true不显示骨架屏，false显示骨架屏)
    */
    visible: boolean
}
