import { BaseProps } from '../../base/props';
import { Direction, FlexJustify } from '../../base/atoms';
export type SpaceAlign = 'start' | 'end' | 'center' | 'baseline';
export interface BaseSpace extends BaseProps {
    /**
    * 间距方向
    */
    direction: Direction
    /**
    * 交叉轴对齐方式
    */
    align: SpaceAlign
    /**
    * 主轴对齐方式
    */
    justify: FlexJustify
    /**
    * 是否自动换行，仅在 horizontal 时有效
    */
    wrap: boolean
}
