import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export type StepStatus = 'wait' | 'process' | 'finish';
export type StepType = 'text' | 'dot' | 'icon';
export type StepLayout = 'single' | 'double';
export type StepDirection = 'horizontal' | 'vertical';
export type StepsStatus = 'default' | 'business' | 'dynamic' | 'enhanced';
export interface BaseStep extends BaseProps {
    title: ReactNode;
    description: ReactNode;
    value: number;
    icon: ReactNode;
    type: StepType;
}
export interface BaseSteps extends BaseProps {
    /**
    * 步骤条的展示状态
    */
    status: StepsStatus
    /**
    * 步骤条的显示方向
    */
    direction: StepDirection
    /**
    * 当前所在的步骤
    */
    value: number
    /**
    * 步骤条的类型
    */
    type: StepType
    /**
    * 步骤条的布局方式
    */
    layout: StepLayout
    /**
    * 自定义图标
    */
    icon: ReactNode
    /**
    * 点击切换步骤条时触发
    */
    onStepClick: (index: number) => void
}
