import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export interface BaseSwitch extends BaseProps {
    /**
    * 开关状态，受控
    */
    checked: boolean
    /**
    * 开关状态，非受控
    */
    defaultChecked: boolean
    /**
    * 禁用状态
    */
    disabled: boolean
    /**
    * 打开时文字描述
    */
    activeText: ReactNode
    /**
    * 关闭时文字描述
    */
    inactiveText: ReactNode
    /**
    * 控制加载状态的图标，传入空值时禁用 loading 态
    */
    loadingIcon: ReactNode
    /**
    * loading 态，受控
    */
    loading: boolean | undefined
    /**
    * 切换 loading 态时触发
    */
    onLoadingChange: (loading: boolean) => void
    /**
    * 切换开关时触发
    */
    onChange: (val: boolean) => void
}
