import { ReactNode } from 'react';
import { BaseProps, Direction } from "../../../types";
export interface BaseTabbar extends BaseProps {
    /**
    * 默认选中的标签的索引值
    */
    defaultValue: number
    /**
    * 选中的标签的索引值
    */
    value?: number
    /**
    * 是否固定在页面底部，为 true 时默认开启 safeArea
    */
    fixed: boolean
    /**
    * icon未激活的颜色
    */
    inactiveColor: string
    /**
    * icon激活的颜色
    */
    activeColor: string
    direction: Direction;
    /**
    * 是否开启iphone系列全面屏底部安全区适配
    */
    safeArea: boolean
    /**
    * 切换页签时触发事件
    */
    onSwitch: (value: number) => void
}
export interface BaseTabbarItem extends BaseProps {
    title: ReactNode | ((active: boolean) => ReactNode);
    icon: ReactNode | ((active: boolean) => ReactNode);
    value: ReactNode | ((active: boolean) => ReactNode);
    dot: boolean;
    max: number;
    top: string;
    right: string;
    direction: Direction;
    onActiveClick: () => void;
}
