import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { PositionX } from '../../base/atoms';
export interface TableColumnProps {
    key: string;
    title?: string;
    align?: string;
    sorter?: ((a: any, b: any) => number) | boolean | string;
    render?: (rowData: any, rowIndex: number) => string | ReactNode;
    fixed?: PositionX;
    width?: number;
}
export interface BaseTable extends BaseProps {
    /**
    * 表头数据
    */
    columns: Array<TableColumnProps>
    /**
    * 表格数据
    */
    data: Array<any>
    /**
    * 是否显示边框
    */
    bordered: boolean
    /**
    * 是否显示简介
    */
    summary?: ReactNode
    /**
    * 条纹是否明暗交替
    */
    striped?: boolean
    /**
    * 自定义无数据
    */
    noData?: ReactNode
    /**
    * 排序 icon
    */
    sorterIcon?: ReactNode
    /**
    * 点击排序按钮触发
    */
    onSort?: (column: TableColumnProps, sortedData: Array<any>) => void
    /**
    * 是否显示表头
    */
    showHeader?: boolean
}
