import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { UIType } from '../../base/atoms';
export interface BaseTag<EVENT = any> extends BaseProps {
    /**
    * 标签类型
    */
    type: UIType
    /**
    * 标签颜色
    */
    background: string
    /**
    * 文本颜色，优先级高于color属性
    */
    color: string
    /**
    * 是否为空心样式
    */
    plain: boolean
    /**
    * 是否为圆角样式
    */
    round: boolean
    /**
    * 是否为标记样式
    */
    mark: boolean
    /**
    * 是否为可关闭标签
    */
    closeable: boolean
    /**
    * 关闭按钮
    */
    closeIcon: ReactNode
    /**
    * 点击事件
    */
    onClick: (e: EVENT) => void
    /**
    * 关闭事件
    */
    onClose: (e: EVENT) => void
}
