import { BaseProps } from '../../base/props';
export interface BaseTextArea<EVENT = any> extends BaseProps {
    /**
    * 输入框内容，受控
    */
    value: string
    /**
    * 初始默认值，非受控
    */
    defaultValue: string
    /**
    * textarea 是否展示输入字符。须配合maxLength使用
    */
    showCount: boolean
    /**
    * 限制最长输入字符，-1 表示无限制
    */
    maxLength: number
    /**
    * textarea 的行数
    */
    rows: number
    /**
    * 设置占位提示文字
    */
    placeholder: string
    /**
    * 只读属性
    */
    readOnly: boolean
    /**
    * 禁用属性
    */
    disabled: boolean
    /**
    * 高度是否可拉伸
    */
    autoSize: boolean
    /**
    * 标记文本域的容器类型，false 为容器型 container, true 为 纯文本型
    */
    plain: boolean
    /**
    * 文本域状态，可标记为 默认状态 和 错误状态
    */
    status: 'error' | 'default'
    /**
    * 输入内容时触发
    */
    onChange: (value: string) => void
    /**
    * 失焦时触发
    */
    onBlur: (event: EVENT) => void
    /**
    * 聚焦时触发
    */
    onFocus: (event: EVENT) => void
}
