import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
export interface TimeType {
    value?: string;
    text?: string;
    [prop: string]: any;
}
export interface TimeSelectDateType {
    value?: string;
    text?: string;
    children?: TimeType[];
    [prop: string]: any;
}
export interface TimeSelectOptionKeyType {
    valueKey: string;
    textKey: string;
    childrenKey: string;
}
export interface BaseTimeSelect extends BaseProps {
    /**
    * 是否显示弹层
    */
    visible: boolean
    /**
    * 是否支持多选
    */
    multiple?: boolean
    /**
    * 弹层标题
    */
    title?: ReactNode
    /**
    * 默认选中的值，非受控
    */
    defaultValue: TimeSelectDateType[]
    /**
    * 数据
    */
    options: TimeSelectDateType[]
    /**
    * 配置数据中的关键字, valueKey, textKey, childrenKey
    */
    optionKey: TimeSelectOptionKeyType
    /**
    * 关闭遮罩之后的回调
    */
    onSelect?: (value: TimeSelectDateType[]) => void
    /**
    * 点击左栏时的回调
    */
    onDateChange?: (date: TimeSelectDateType, value: TimeSelectDateType[]) => void
    /**
    * 点击右侧选项时的回调
    */
    onTimeChange?: (time: TimeType, value: TimeSelectDateType[]) => void
}
export interface BaseTimeSelectDetail extends BaseProps {
    activeDate: string;
    activeTime: TimeSelectDateType[];
    options: TimeSelectDateType[];
    optionKey: TimeSelectOptionKeyType;
    onSelect: (time: TimeType) => void;
}
