import { CSSProperties, ReactNode } from 'react';
import { UISize, VAlign } from '../../base/atoms';
export type ToastIcon = 'success' | 'fail' | 'loading' | 'warn' | ReactNode;
export type ToastWordBreak = 'normal' | 'break-all' | 'break-word';
export type ToastSize = Extract<UISize, 'large' | 'small'> | 'base';
export type BaseToast<OVERLAY_PROPS> = OVERLAY_PROPS & {
    id: string;
    /**
    * toast展示位置
    */
    position: VAlign
    /**
    * 标题
    */
    title: string
    /**
    * 文案尺寸，三选一
    */
    size: ToastSize
    /**
    * 自定义图标
    */
    icon: ToastIcon
    /**
    * 消息文本内容
    */
    content: ReactNode
    /**
    * 自定义内容区类名
    */
    contentClassName: string
    /**
    * 自定义内容区样式
    */
    contentStyle: CSSProperties
    /**
    * 换行截断方式
    */
    wordBreak: ToastWordBreak
    /**
    * 关闭时触发的事件
    */
    onClose: () => void
};
