import { BaseProps } from '../../base/props';
export type BaseVideo<TaroVideo = any> = TaroVideo & BaseProps & {
    /**
    * 视频地址和类型设置
    */
    source: {
        type: string;
        src: string;
    }
    /**
    * 控制视频播放属性
    */
    options: {
        controls?: boolean;
        muted?: boolean;
        autoplay?: boolean;
        poster?: string;
        playsinline?: boolean;
        loop?: boolean;
    }
    /**
    * 播放
    */
    onPlay?: (element: any) => void
    /**
    * 暂停
    */
    onPause?: (element: any) => void
    /**
    * 播放完成回调
    */
    onPlayEnd?: (element: any) => void
};
