import { ReactNode } from 'react';
import { BaseProps } from '../../base/props';
import { Direction } from '../../base/atoms';
export interface BaseVirtualList extends BaseProps {
    /**
    * 获取数据
    */
    list: Array<any>
    /**
    * 容器高度
    */
    containerHeight: number
    /**
    * virtual 列表父节点渲染的函数
    */
    itemRender: (data: any, dataIndex: number, index: number) => ReactNode
    /**
    * item 高度，如果不定高，则为首屏单个最大 height
    */
    itemHeight: number
    /**
    * item 高度是否一致
    */
    itemEqual: boolean
    /**
    * vertical、horizontal
    */
    direction: Direction
    /**
    * 除了视窗里面默认的元素, 还需要额外渲染的 item 个数
    */
    overscan: number
    /**
    * 滑动到底(右)的事件，可以实现无限滚动
    */
    onScroll: () => void
    /**
    * 用于指定 list 数据每一项的唯一 key 的字段名，默认取下标
    */
    key: string
}
