import { BaseProps } from '../../base/props';
import { SimpleValue } from '../../base/atoms';
export interface BaseWaterMark extends BaseProps {
    /**
    * 水印文字内容
    */
    content: string
    /**
    * 是否覆盖整个页面
    */
    fullPage: boolean
    /**
    * 追加的水印元素的 z-index
    */
    zIndex: number
    /**
    * 水印之间的水平间距
    */
    gapX: number
    /**
    * 水印之间的垂直间距
    */
    gapY: number
    /**
    * 水印之间的水平起点
    */
    startX: number
    /**
    * 水印之间的垂直起点
    */
    startY: number
    /**
    * 水印的宽度
    */
    width: number
    /**
    * 水印的高度
    */
    height: number
    /**
    * 图片源，建议导出 2 倍或 3 倍图，优先使用图片渲染水印
    */
    image: string
    /**
    * 图片宽度
    */
    imageWidth: number
    /**
    * 图片高度
    */
    imageHeight: number
    /**
    * 水印绘制时，旋转的角度
    */
    rotate: number
    /**
    * 水印文字颜色
    */
    color: string
    fontStyle: string;
    /**
    * 水印文字字体
    */
    fontFamily: string
    fontWeight: string;
    /**
    * 文字大小
    */
    fontSize: SimpleValue
}
