import React from "react";
import { harmony } from "./platform";
/**
 * 为支持 Harmony 的 React 元素添加颜色属性
 * @param maybeElement - 要处理的 React 节点
 * @param color - 要添加的颜色值（如：'#ff0000'）
 * @returns 处理后的 React 节点
 */ export function addColorForHarmony(maybeElement, color) {
    if (React.isValidElement(maybeElement) && harmony()) {
        return React.cloneElement(maybeElement, {
            color: color
        });
    }
    return maybeElement;
}
