import { canIUse, getAppBaseInfo as taroGetAppBaseInfo, getDeviceInfo as taroGetDeviceInfo, getSystemInfoSync, getWindowInfo as taroGetWindowInfo } from "@tarojs/taro";
/**
 * 获取设备基础信息，兼容新旧 API
 * @returns {IDeviceInfo} 设备基础信息
 */ export var getDeviceInfo = function() {
    return canIUse('getDeviceInfo') ? taroGetDeviceInfo() : getSystemInfoSync();
};
/**
 * 获取窗口信息，兼容新旧 API
 * @returns {Taro.getWindowInfo.Result} 窗口信息
 */ export var getWindowInfo = function() {
    return canIUse('getWindowInfo') ? taroGetWindowInfo() : getSystemInfoSync();
};
/**
 * 获取应用基础信息，兼容新旧 API
 * @returns {Taro.getAppBaseInfo.Result} 应用基础信息
 */ export var getAppBaseInfo = function() {
    return canIUse('getAppBaseInfo') ? taroGetAppBaseInfo() : getSystemInfoSync();
};
